/***********************************************************************
* ------------------------------------------
* Bustedware LLC - 2015
* https://www.bustedware.com
* ------------------------------------------
* 
* This file is free to distribute
* Please see LICENSE_1_0.txt included with this release
* 
//*********************************************************************/

#ifndef BWFILESYSTEM_H
#define BWFILESYSTEM_H

#include <iostream>

#ifdef _WIN32
	#include <Windows.h>
#elif __linux__
	#include <sys/stat.h>
	#include <dirent.h>
	#include <sys/stat.h>
#endif

#include <fstream>
#include <string>
#include "BWStrings.h"
using namespace std;

class BWFileSystem
{
public:
	static string* GetFileName(const char* filename);	
	
	static bool CreateDir(const char* path);
	#ifdef __linux__
	static bool CreateDir(const char* path, mode_t mode);
	#endif	
	
	static int GetNumberOfFilesInFolder(const char* folderPath);
	static string* GetFileExtension(const char* filename);
	
	static string* ReadFileAsString(const char* filename);
	static char* ReadFileAsBytes(const char* filename, int* read);
	
	static bool GetFreeSpaceLeft(const char* path, unsigned long* lpSectorsPerCluster,
		unsigned long* lpBytesPerSector, unsigned long* lpNumberOfFreeClusters,
		unsigned long* lpTotalNumberOfClusters);
		
	static void NormalizeFilePath(string& filepath, char slashType);
};

#endif
